﻿using UnityEngine;
using System.Collections;

public class AnimationScript : MonoBehaviour {
    MeshRenderer parent;
    int frame = -1;
    public int frameCount = 4;
    float frameDelay = 1.0f / 7.0f;
    float acc = 0.0f;
    Material material;

    void Awake()
    {
        material = GetComponent<MeshRenderer>().material;
    }
    public void Execute(MeshRenderer parent)
    {
        this.parent = parent;
        parent.enabled = false;
        frame = 0;
        this.GetComponent<MeshRenderer>().enabled = true;
        acc = 0.0f;
    }
	
	// Update is called once per frame
	void Update () {
        if (frame < 0) return;
        material.SetFloat("_Frame", (float)frame);
        acc += Time.deltaTime;
        if (acc >= frameDelay)
        {
            acc -= frameDelay;
            frame++;
        }
        if (frame >= frameCount)
        {
            this.GetComponent<MeshRenderer>().enabled = false;
            parent.enabled = true;
            frame = -1;
        }
	}
}
