﻿using UnityEngine;
using System.Collections;

public class BibleScript : ObstacleScript {
    public float angle;
    public float speed = 0.12f;
    public bool active = false;
    Material material;
    int frame = 0;
    Vector3 speedv;

    public GameObject explosionPrefab;

    public override void Trigger()
    {
        active = true;
    }

	// Use this for initialization
    void Start()
    {
		material = GetComponent<MeshRenderer>().material;
		speedv = new Vector3(Mathf.Cos(angle), Mathf.Sin(angle), 0.0f) * speed;
	
	}
	
	// Update is called once per frame
    void Update()
    {
        if (active)
        {
            frame++;
            material.SetFloat("_Frame", (float)(int)(frame / 2
                ));
            this.transform.Translate(speedv);
        }
	}

    void OnCollisionEnter2D(Collision2D info)
    {
        if (active)
        {
			SoundPlayer.Self.Play (1);
            Instantiate(explosionPrefab, this.transform.position, this.transform.rotation);
            Destroy(this.gameObject);
        }
    }
}
