﻿using UnityEngine;
using System.Collections;
using UnityStandardAssets.ImageEffects;

public class CameraShakeScript : MonoBehaviour {
    PlayerScript player;
    Vector3 basePosition;
    public float shakeSpeed = 1.0f;
    public float shakeAmount = 1.0f;
	public float sizeMultiplier = 2.0f;
    MotionBlur blurScript;
	Camera camera;

	// Use this for initialization
	void Start () {
        player = PlayerScript.Self;
        basePosition = this.transform.localPosition;
        blurScript = GetComponent<MotionBlur>();
		camera = GetComponent<Camera> ();
	}
	
	// Update is called once per frame
	void Update () {
        if (player.lives > 0)
        {
            float delta = player.GetNormalizedDistanceToMob();
            Vector3 position = basePosition + Vector3.up * delta * Mathf.Sin(Time.time * shakeSpeed) * delta * shakeAmount + Vector3.right * delta * 0.2f;
            this.transform.localPosition = position;
            if (blurScript != null) blurScript.blurAmount = delta * 0.3f;
            camera.orthographicSize = 4.5f + delta * sizeMultiplier;
            camera.fieldOfView = 70.0f - delta * sizeMultiplier;
        }
	}
}
