﻿using UnityEngine;
using System.Collections;

[ExecuteInEditMode]
public class TerrainScript : MonoBehaviour {
    public GameObject[] renders = null;
    public float borderSize = 0.1f;

	// Use this for initialization
	void Start () {
        if (Application.isEditor && renders == null)
        {
            renders = new GameObject[9];
            for (int i = 0; i < 9; i++)
            {
                renders[i] = new GameObject();
                renders[i].transform.parent = this.transform;
                renders[i].name = "DrawingSection#" + i;
            }
        }
	}
	
	// Update is called once per frame
	void Update () {
        if (Application.isEditor)
        {
            for (int i=0; i<9; i++) {
                renders[0].transform.parent = null;
            }
            float xScale = this.transform.localScale.x;
            float yScale = this.transform.localScale.y;
            renders[0].transform.localScale = new Vector3(borderSize, borderSize, 1.0f);
            renders[1].transform.localScale = new Vector3(xScale - 2.0f * borderSize, borderSize, 1.0f);
            renders[2].transform.localScale = new Vector3(borderSize, borderSize, 1.0f);
            renders[3].transform.localScale = new Vector3(borderSize, yScale - 2.0f * borderSize, 1.0f);
            renders[4].transform.localScale = new Vector3(xScale - 2.0f * borderSize, yScale - 2.0f * borderSize, 1.0f);
            renders[5].transform.localScale = new Vector3(borderSize, yScale - 2.0f * borderSize, 1.0f);
            renders[6].transform.localScale = new Vector3(borderSize, borderSize, 1.0f);
            renders[7].transform.localScale = new Vector3(xScale - 2.0f * borderSize, borderSize, 1.0f);
            renders[8].transform.localScale = new Vector3(borderSize, borderSize, 1.0f);
            
            for (int i=0; i<9; i++) {
                renders[0].transform.parent = this.transform;
                renders[0].transform.localPosition = Vector3.zero;
            }

            renders[1].transform.localPosition += Vector3.right * borderSize;
        }
	}
}
